<template>
  <div>
    <b-modal v-model="showModal" id="loginModalId" hide-footer title="Registration">
      <div>
        <b-form>
          <b-form>
            <label class="mb-0">User ID</label>
            <b-form-input v-model="form.username"
                          id="loginUserInputId"
                          :disabled="isSubmitting"
                          placeholder="Enter the user"
            ></b-form-input>
          </b-form>

          <div class="mt-4">
            <b-form>
              <label class="mb-0">Password</label>
              <b-form-input v-model="form.password"
                            id="loginPasswordInputId"
                            placeholder="Enter the password"
                            :disabled="isSubmitting"
                            type="password"
                            aria-describedby="password-help-block"
              ></b-form-input>
            </b-form>
          </div>

          <div class="mt-5">
            <b-button class="mr-3" id="loginSubmitButtonId" variant="primary" @click="onSubmit" v-if="!isSubmitting">
              Submit
            </b-button>
            <b-button class="mr-3" variant="primary" disabled v-if="isSubmitting">
              <b-spinner small type="grow"></b-spinner>
              Loading...
            </b-button>
            <b-button type="reset" variant="danger" :disabled="isSubmitting" @click="onReset">Reset</b-button>
          </div>
        </b-form>
        <b-form-text v-if="isErrorSubmitted">
              <span style="color: red">
                {{ typeOfErrorSubmitted }}
              </span>
        </b-form-text>
      </div>
    </b-modal>
  </div>
</template>

<script>
import Vuex from "vuex";

import Store from '../../stores/Store';

export default {
  name: 'Registration',
  store: Store,
  data() {
    return {
      form: {
        username: '',
        password: '',
      },
      isErrorSubmitted: false,
      isSubmitting: false,
      showModal: false,
      typeOfErrorSubmitted: ''
    }
  },
  methods: {
    ...Vuex.mapMutations([
      'setUserByStoreAsLogged'
    ]),
    onReset() {
      this.form.username = ''
      this.form.password = ''
    },
    onSubmit() {
      this.isSubmitting = true;
      this.isErrorSubmitted = false;
      this.$http.post('resource/login-user', this.form).then(
          () => {
            this.$swal.fire({
              title: 'Success!',
              text: 'The sign in si completed!',
              icon: 'success',
              confirmButtonText: 'Cool'
            }).then(() => {
              this.onReset();
              this.showModal = false;
              this.setUserByStoreAsLogged(this.form.username);
            });
          },
          (event) => {
            this.isErrorSubmitted = true;
            this.$swal.fire({
              title: 'Error!',
              text: 'Uhm, there is an error, please check username and/or password',
              icon: 'error',
              confirmButtonText: 'Cool'
            });
            switch (event.status) {
              case (500): {
                this.typeOfErrorSubmitted = 'Uhm, there is an error, please check username and/or password';
                break;
              }
              default: {
                this.typeOfErrorSubmitted = 'Uhm, there is an error, please check username and/or password';
              }
            }
          }).then(() => {
        this.isSubmitting = false;
      });
    },
    showModalAction() {
      this.showModal = true;
      this.isErrorSubmitted = false;
    }
  }
}
</script>
